#   File Name: fix_restore_file.sh
#
#  Purpose:  This scripts fixes RESTORE script created by backup 
#            and make it ready to restore 
#

#   Created by  :  Ajay Jain  01/15/03
#   Modified by :


ERRMSG="`basename $0`: syntax error: `basename $0`  sid "
if [ "$1" ]; then HOST_STR=$1; else echo $ERRMSG >&2; exit 1; fi

BKUP_SCR=/orabackup/scripts
BACKUP_DIR=/orabackup/$HOST_STR
FILE_NAME=$BACKUP_DIR/last_backup_dir_name_cold_${HOST_STR}.txt
CURRENT_BACKUP_DIR="/orabackup/$HOST_STR/cold"
LAST_BACKUP_DIR=`cat $FILE_NAME`
RESTORE_FILE=$LAST_BACKUP_DIR/RESTORE_${HOST_STR}.sh

RESTORE_FILE1=$LAST_BACKUP_DIR/restore_${HOST_STR}_1.sh
RESTORE_FILE2=$LAST_BACKUP_DIR/restore_${HOST_STR}_2.sh
MAIN_RESTORE_FILE=$LAST_BACKUP_DIR/restore_${HOST_STR}.sh
LOG_UNCOMPRESS=/tmp/log_uncompress_$HOST_STR.log


echo " Last Backup Directory = $LAST_BACKUP_DIR "

echo " \n Changing File Permissions for $RESTORE_FILE"
chmod 755 $RESTORE_FILE

echo " Removing All comments from  $RESTORE_FILE "
cat $RESTORE_FILE |sed 's,####,,g' > $RESTORE_FILE1

echo " Fixing Dir name $RESTORE_FILE "
echo " CURRENT = $CURRENT_BACKUP_DIR "
echo " LAST    = $LAST_BACKUP_DIR "
cat $RESTORE_FILE1 |sed "s, ${CURRENT_BACKUP_DIR}, ${LAST_BACKUP_DIR},g" > $RESTORE_FILE2

cp $RESTORE_FILE2 $MAIN_RESTORE_FILE 
rm $RESTORE_FILE1 $RESTORE_FILE2 
chmod 755 $MAIN_RESTORE_FILE

# *** Check if instance is up,
   echo "\nChecking if instance is up ..."
   SMON_PROCESS=`ps -ef | grep "ora_smon_${HOST_STR}"|grep -v grep| wc -l`
     if [ "$SMON_PROCESS" -gt  "0" ]
       then
           echo "\n  Instance is up, It will be shutdown NOW...."
           $BKUP_SCR/shutdown_db_2.sh    $HOST_STR
        else
           echo " \n  INSTANCE  is already down, going ahead with RESTORE .."
     fi

# *** Check 2nd time if instance is up,
   echo "\nChecking 2nd time if instance is up ..."
   SMON_PROCESS=`ps -ef | grep "ora_smon_${HOST_STR}"|grep -v grep| wc -l`
     if [ "$SMON_PROCESS" -gt  "0" ]
       then
        echo "\n  Instance is STILL up, it did not went down, status = $SMON_PROCESS "
        exit 1
      else
       echo " Instance up check 2nd time done "
     fi


echo " \n Starting to refresh the database now   "
  
 $MAIN_RESTORE_FILE | tee $LOG_UNCOMPRESS
  STATUS=$?
# *** Checking uncompress error from LOG files
echo "\n  Checking log file=$LOG_UNCOMPRESS  for uncpomress errors"
ERROR_COUNT=`grep "Status: 1" $LOG_UNCOMPRESS | wc -l`
if [ $ERROR_COUNT -gt 0 ]
 then 
   echo " Errors in Uncompressing the Files "
   echo " Either No space left on device OR input file does not exists OR output dir does not exists"
   echo " Please check error file = $LOG_UNCOMPRESS "
   echo " Number of errors found = $ERROR_COUNT "
   exit 1
 else 
  echo " No errors found in uncompressing the files "
  echo "\n Uncompressing of all files have been completed"
     echo " Starting the database "
     $BKUP_SCR/startup_db.sh $HOST_STR
      status=$?
      if [ ! $status -eq 0 ]
         then
           echo "/n  problem with starting up the database  exiting now .."
           exit 1
         else
           echo " Database restore completed successfully "
      fi

fi

 
 


